{
  description = "Opinionated Nixvim config as a flake";

  inputs = {
    ## nixvim uses it's own version, so this is only
    ## for explicitly installed packages and non nixvim config
    nixpkgs.url = "github:NixOS/nixpkgs/nixos-unstable";

    flake-utils.url = "github:numtide/flake-utils";

    nixvim = {
      url = "github:nix-community/nixvim";
    };

  };

  outputs = { nixpkgs, flake-utils, ... } @ inputs:
  flake-utils.lib.eachDefaultSystem (system:
  let
    pkgs = nixpkgs.legacyPackages.${system};
  in
  {
    nixosModules = rec {
      nixvim-config = import ./default.nix {
        inherit inputs;
        inherit pkgs;
      };
      default = nixvim-config;
    };
  });
}
